<?php // $Id: act_structs.php,v 1.18 2004/10/11 10:42:43 mario Exp $

/**************************************************************************
 * mg.applanix, Copyright (C) by Mario Gleirscher                         *
 * mg.applanix comes with ABSOLUTELY NO WARRANTY; This is free software,  *
 * and you are welcome to redistribute it under certain conditions;       *
 * view the file COPYING for details.                                     *
 **************************************************************************/

// PHP 5 required

class APXSurveyList
{
    var $url_action;        // STRING
    var $url_rowaction;     // STRING
    var $url_sp_action;     // STRING
    var $title;             // STRING

    var $filter;            // BOOL, Filterformular anzeigen
    var $filter_crits;      // ((MIXED)ARRAY[5])ARRAY[]
                            // 1. Eintrag muss immer DB-Feld fuer Anfangsbuchstaben sein
                            // wenn $letters = true!!! Das ist das Sortierkriterium
                            // der Liste (z. B. ein Name)

    var $letters;           // BOOL, Buchstabenleisten anzeigen
    var $letters_dbfield;   // STRING

    var $columns;           // ((MIXED)ARRAY[4])ARRAY[]
    var $sysdel;            // BOOL, Systemeintrag in Tabellen loeschbar?

    var $multidel;          // BOOL, Mehrfachloeschen in Liste moeglich?
    var $multimark;         // BOOL, Mehrfachmarkierungen in Liste moeglich?
    var $dbtable;           // STRING, Tabelle

    var $dbquery_script;    // STRING
    var $edit_idfield;      // STRING
    var $dbquery;           // STRING
    var $cntquery;          // STRING

    var $msg_emptylist;     // STRING
    var $msg_createrow;     // STRING
    var $msg_orderby;       // STRING

    function __construct(
        $url_action, $url_rowaction, $url_sp_action, $title, $filter, $letters,
        $letters_dbfield, $dbquery_script, $edit_idfield, $dbquery,
        $cntquery = '', $sysdel = true
        )
    {
        $this->url_action       = $url_action;
        $this->url_rowaction    = $url_rowaction;
        $this->url_sp_action    = $url_sp_action;
        $this->title            = $title;
        $this->filter           = $filter && ( $cntquery != '' );
        $this->letters          = $letters && $filter;
        $this->letters_dbfield  = $letters_dbfield;
        $this->dbquery_script   = $dbquery_script;
        $this->edit_idfield     = $edit_idfield;
        $this->dbquery          = $dbquery;
        $this->cntquery         = $cntquery;
        $this->sysdel           = $sysdel;
        $this->multidel         = false;
        $this->multimark        = false;

        $this->filter_crits     = array();
        $this->columns          = array();
    }

    function enableMultiDel( $dbtable, $multimark = false )
    {
        $this->multidel         = true;
        $this->dbtable          = $dbtable;
        $this->multimark        = $multimark;
    }

    function initMessages( $msg_emptylist, $msg_createrow, $msg_orderby = '')
    {
        $this->msg_emptylist    = $msg_emptylist;
        $this->msg_createrow    = $msg_createrow;
        $this->msg_orderby      = $msg_orderby;
    }

    function addFilterCrit( $crit, $field, $type, $vartoset, $default )
    {
        $aNewCrit = array(
            'crit'      => $crit,
            'type'      => $type,
            'default'   => $default,
            'vartoset'  => $vartoset,
            'field'     => $field );
        array_push( $this->filter_crits, $aNewCrit );
    }

    function addColumn( $header, $type, $cellcontent, $cssclass = '' )
    {
        $aNewColumn = array(
            'header'        => $header,
            'type'          => $type,
            'cellcontent'   => $cellcontent,
            'cssclass'      => $cssclass );
        array_push( $this->columns, $aNewColumn );
    }
}


class APXDataForm
{
    var $form_name;         // STRING
    var $form_action;       // STRING (z. B. wenn Formular mit Mail versendet werden soll)
    var $url_listaction;    // STRING
    var $columns;           // INT

    var $actions;           // ((MIXED)ARRAY[2])ARRAY[3]
    var $disabled_actions;  // STRING (z. B. Wenn nur als Formulargenerator verwendet)
    var $dbtable;           // STRING
    var $id_field;          // STRING
    var $fields;            // ((MIXED)ARRAY[])ARRAY[]
    var $editorlog;         // BOOL
    var $maxitems;          // INT

    var $checkform;         // BOOL
    var $javascript;        // STRING
    var $delbutton;         // BOOL

    var $msg_dberror;       // STRING

    function __construct(
        $form_name, $url_listaction, $columns, $dbtable, $id_field,
        $editorlog = false, $msg_dberror = '', $delbutton = true,
        $cusctl_script = '', $maxitems = 0, $disabled_actions = '',
        $form_action = ''
        )
    {

        // Globale Variablen
        global $apx_maxitems;

        $this->url_listaction   = trim( $url_listaction );
        $this->form_name        = trim( $form_name );
        $this->form_action      = trim( $form_action );
        $this->columns          = $columns;
        $this->dbtable          = trim( $dbtable );
        $this->id_field         = trim( $id_field );
        $this->checkform        = false;
        $this->editorlog        = $editorlog;
        $this->msg_dberror      = trim( $msg_dberror ) == '' ?
                                  ' ['._( 'Form' ).':'.$form_name.'] ' :
                                  $msg_dberror;
        $this->delbutton        = $delbutton;
        $this->cusctl_script    = trim( $cusctl_script );

        $this->maxitems         = $maxitems ? $maxitems : $apx_maxitems;

        // Vordefinierte Form-Actions
        $this->actions          = array(
            'i'    => array( 'headline' => _( 'Insert new item' ),
                             'button' => _( 'Save data' ) ),    // insert
            'u'    => array( 'headline' => _( 'Update item' ),
                             'button' => _( 'Save changes' ) ), // update
            'd'    => array( 'headline' => _( 'Delete item' ),
                             'button' => _( 'Delete data' ) )   // delete
            );
        $this->disabled_actions = $disabled_actions;

        $this->fields           = array();
    }

    function initMessages( $action, $msg_headline = '', $msg_button = '' )
    {
        if( !empty( $msg_headline ) )
            $this->actions[ $action ][ 'headline' ] = $msg_headline;
        if( !empty( $msg_button ) )
            $this->actions[ $action ][ 'button' ]   = $msg_button;
    }

    function setJavascript( $script )
    {
        // skript besteht nur aus If-Klauseln, die im
        // Fehlerfall "return false" liefern
        $this->javascript = $script;
        $this->checkform  = ( trim( $script ) != '' );
    }

    function addField( $name, $ftype, $subftype, $vtype, $default = 0, $size = 0,
                       $maxlength = 0, $dataset = '', $required = false, $sqlfilter = '' )
    {
        $this->fields[ $name ] = array(
            'name'          => $name,
            'ftype'         => $ftype,      // type of field
            'subftype'      => $subftype,   // subtype of field
            'vtype'         => $vtype,      // type of value
            'default'       => $default,
            'size'          => $size,       // groesse eingabefeld
            'maxlength'     => $maxlength,  // laenge datenfeld
            'dataset'       => $dataset,
            'required'      => $required,   // gueltiger wert?
            'sqlfilter'     => $sqlfilter   // zusaetzliche SQL-Filteranweisung, noch nicht in Gebrauch!
            );
    }
}


// mg.applanix - Einfache Datenbankabstraktion
// Vorlaeufiger Ersatz fuer PEAR-DB-Klasse (http://pear.php.net)
// Es wird spaeter auf die PEAR-DB-Klasse umgestiegen

// Einfaches DBX-kompatibles Objekt
// Allerdings ohne das Feld info (Felder, Feldtypen)
class APXDBAObject
{
    var $data;      // (MIXED) ARRAY[][]
    var $rows;      // INT
    var $cols;      // INT

    function __construct()
    {
        $this->data = array();
        $this->rows = 0;
        $this->cols = 0;
    }
}

// Abstraktionslayer Funktionalitaet
class APXDBALayer
{

    var $system;            // STRING
    var $system_dbx;        // STRING
    var $host;              // STRING
    var $port;              // STRING
    var $name;              // STRING
    var $user;              // STRING
    var $password;          // STRING
    var $tableprefix;       // STRING
    var $backuppath;        // STRING
    var $flags;             // INT

    // PHP Module, Unterstuetzte Datenbanken
    var $support;           // (STRING) ARRAY[]

    var $con_id;            // MIXED (INT,ARRAY,OBJECT)

    function checkAndLoadModule( $module )
    {
        global $apx_errors;
        global $apx_php_mver;
        global $apx_php_sver;

        $s_php_os       = strtoupper( substr( PHP_OS, 0, 3 ) );
        $a_loaded_ext   = get_loaded_extensions();
        $b_ext_loaded   = in_array( $module, $a_loaded_ext );

        if( !$b_ext_loaded && $module ) {
            switch( $s_php_os ) {
            case 'WIN':
                $b_ext_loaded = extension_loaded( 'php_'.$module.'.dll' ); break;
            case 'OS2':
                $b_ext_loaded = extension_loaded( $module.'.dll' ); break;
            default:
                $b_ext_loaded = extension_loaded( $module.'.so' );
            }
        }

        if( !$b_ext_loaded )
            trigger_error( $apx_errors[ 18 ].$module, E_USER_ERROR );

        return $b_ext_loaded;
    }

    function __construct( $system, $server, $name, $user, $password,
                          $tableprefix, $backuppath, $use_dbx = false )
    {
        // Vars initialisieren
        $this->support     = array( 'odbc', 'mysqli', 'pgsql', 'dbx' );

        // Ueberpruefen, ob benoetigtes DB-System installiert ist

        if( in_array( $system, $this->support ) &&
            $this->checkAndLoadModule( $system ) )
            $this->system  = $system;
        else
            $this->system  = 'none';

        if( $use_dbx ) {
            $this->system  = 'dbx';
            $this->system_dbx = $system;
        }
	
	$i_pos = strrpos( $server, ':' );
        if( $i_pos ) {
            $this->host        = substr( $server, 0, $i_pos );
            $this->port        = substr( $server, $i_pos + 1 );
        }
        else {
            $this->host        = $server;
            $this->port        = '';
        }

        $this->name        = $name;
        $this->user        = $user;
        $this->password    = $password;
        $this->tableprefix = $tableprefix;
        $this->backuppath  = $backuppath;

        $this->con_id      = 0;
        $this->flags       = 0;
    }

    function connect()
    {
        switch( $this->system ) {
        case 'mysqli':
            $this->con_id = new mysqli( $this->host, $this->user, $this->password, 
					$this->name, 0+$this->port );
            break;
        case 'pgsql':
            $this->con_id = pg_connect( "host=$this->host port=$this->port dbname=$this->name ".
                                        "user=$this->user password=$this->password" );
            break;
        case 'odbc':
            $this->flags = SQL_CUR_USE_ODBC; // | SQL_CURSOR_FORWARD_ONLY;
            $this->con_id = odbc_connect( $this->name, $this->user,
                                          $this->password, $this->flags );
            break;
        case 'dbx':
            // DBX spezifisch: DBX-Abfragen sind dann intuitiver zu handhaben
            if( $apx_php_mver >= 4 && $apx_php_sver >= 3 ) { // Fuer PHP 4.3.x
                $this->flags = DBX_RESULT_INDEX | DBX_RESULT_ASSOC |
                                 DBX_COLNAMES_LOWERCASE;
            }
            else
                $this->flags = DBX_RESULT_INDEX | DBX_RESULT_ASSOC;
            $this->con_id = dbx_connect( $this->system_dbx,
                                         $this->host.$this->port, $this->name,
                                         $this->user, $this->password );
            break;
        default:
            return false;
        }

        return $this->con_id ? true : false;
    }

    function buildArray( $query_object )
    {
        global $apx_db_debug;

        if( is_bool( $query_object ) || is_null( $query_object ) )
            return $query_object;

        $query_data = new APXDBAObject();

        switch( $this->system ) {
        case 'mysqli':
            while( $query_row = $query_object->fetch_assoc() )
                array_push( $query_data->data, $query_row );
            $query_data->rows = count( $query_data->data );
            $query_data->cols = $query_object->field_count;
            $query_object->free();
            break;
        case 'pgsql':
            while( $query_row = pg_fetch_assoc( $query_object ) )
                array_push( $query_data->data, $query_row );
            $query_data->rows = count( $query_data->data );
            $query_data->cols = pg_num_fields( $query_object );
            pg_free_result( $query_object );
            break;
        case 'odbc':
            $a_cols           = array();
            $query_data->cols = odbc_num_fields( $query_object );
            if( $query_data->cols ) { // bei Update und Deletes
                // @debug Fehlermeldungen unterdrcken wg. ODBC-Access-Treiberbug???
                //error_reporting( 0 ); // ausschalten
                //ini_set( "display_errors", "no" );
                //restore_error_handler();

                while( odbc_fetch_row( $query_object ) ) {
                    for( $i = 1; $i <= $query_data->cols; $i++ ) {
                        if( $apx_db_debug )
                            echo $i.". ".odbc_field_name( $query_object, $i )." = '".
                                 odbc_result( $query_object, $i )."'<br/>";

                        $a_cols[ odbc_field_name( $query_object, $i ) ] =
                            odbc_result( $query_object, $i );
                    }
                    array_push( $query_data->data, $a_cols );
                }

                // @debug
                //error_reporting( $apx_error_reporting ); // wieder einschalten
                //set_error_handler( 'apxMsg' );

                $query_data->rows = count( $query_data->data );
            }
            odbc_free_result( $query_object );
            break;
        case 'dbx':
        default:
            return false;
        }
        return $query_data->rows ? $query_data : $query_object;
    }

    function query( $query )
    {
        global $apx_db_debug;

        if( $apx_db_debug )
            trigger_error( _( "Query-Log:<br/>" ).$query, E_USER_NOTICE );

        switch( $this->system ) {
        case 'mysqli': $query_object = $this->con_id->query( $query );           break;
        case 'pgsql': $query_object = pg_query( $this->con_id, $query );        break;
        case 'odbc':  $query_object = odbc_exec( $this->con_id, $query );       break;
        case 'dbx':   return dbx_query( $this->con_id, $query, $this->flags );
        default:      return false;
        }
        return APXDBALayer::buildArray( $query_object );
    }

    function close()
    {
        switch( $this->system ) {
        case 'mysqli':   return $this->con_id->close();
        case 'pgsql':   return pg_close( $this->con_id );
        case 'odbc':    return odbc_close( $this->con_id );
        case 'dbx':     return dbx_close( $this->con_id );
        default:        return false;
        }
    }

    function error()
    {
        switch( $this->system ) {
        case 'mysqli':   return $this->con_id->error;
        case 'pgsql':   return pg_last_error( $this->con_id ).'<br />'.
                               pg_last_notice( $this->con_id );
        case 'odbc':    return odbc_error( $this->con_id ).': '.
                               odbc_errormsg( $this->con_id );
        case 'dbx':     return dbx_error( $this->con_id );
        default:        return false;
        }
    }

    function info()
    {
        $s_info = '<u>'._( "Database information" ).':</u><br />';

        switch( $this->system ) {
        case 'mysqli':
            $s_info .= _( "MySQL: <br />" ).
            _( "Client info: " ).$this->con_id->get_client_info()."<br />".
            _( "Host info: " ).$this->con_id->host_info."<br />".
            _( "Protocol version: " ).$this->con_id->protocol_version."<br />".
            _( "Server version: " ).$this->con_id->server_info."<br />";
            break;
        case 'pgsql':
            $s_info .= _( "PostGreSQL: <br />" ).pg_options();
            break;
        case 'odbc':
            $s_info .= _( "ODBC connection information" ).":<br />";
            foreach( odbc_data_source( $this->con_id, SQL_FETCH_FIRST ) as $sInfoline )
                $s_info .= "$sInfoline <br />";
            break;
        case 'dbx':
            break;
        default:
        }

        return $s_info;
    }

    function escape_string( $str )
    {
        /*
        if( get_magic_quotes_gpc() )
            return $str;
        */

        switch( $this->system ) {
        case 'mysqli':   return $this->con_id->real_escape_string( $str );
        case 'dbx':     return dbx_escape_string( $this->con_id, $str );
        case 'pgsql':   // ab PostGreSQL 7.2: pg_escape_string()
        case 'odbc':    return addslashes( $str );
        default:        return $str;
        }
    }
}

?>
